declare module 'mii-js';

// TODO - These have limits, and should be validated

type MiiStudioURLOptions = {
	type?: string;
	expression?: string;
	width?: number;
	bgColor?: string;
	clothesColor?: string;
	cameraXRotate?: number;
	cameraYRotate?: number;
	cameraZRotate?: number;
	characterXRotate?: number;
	characterYRotate?: number;
	characterZRotate?: number;
	lightXDirection?: number;
	lightYDirection?: number;
	lightZDirection?: number;
	lightDirectionMode?: string;
	instanceCount?: number;
	instanceRotationMode?: string;
};

type Mii = {
	version: number;
	allowCopying: boolean;
	profanityFlag: boolean;
	regionLock: number;
	characterSet: number;
	pageIndex: number;
	slotIndex: number;
	unknown1: number;
	deviceOrigin: number;
	systemId: Buffer;
	normalMii: boolean;
	dsMii: boolean;
	nonUserMii: boolean;
	isValid: boolean;
	creationTime: number;
	consoleMAC: Buffer;
	gender: number;
	birthMonth: number;
	birthDay: number;
	favoriteColor: number;
	favorite: boolean;
	miiName: string;
	height: number;
	build: number;
	disableSharing: boolean;
	faceType: number;
	skinColor: number;
	wrinklesType: number;
	makeupType: number;
	hairType: number;
	hairColor: number;
	flipHair: boolean;
	eyeType: number;
	eyeColor: number;
	eyeScale: number;
	eyeVerticalStretch: number;
	eyeRotation: number;
	eyeSpacing: number;
	eyeYPosition: number;
	eyebrowType: number;
	eyebrowColor: number;
	eyebrowScale: number;
	eyebrowVerticalStretch: number;
	eyebrowRotation: number;
	eyebrowSpacing: number;
	eyebrowYPosition: number;
	noseType: number;
	noseScale: number;
	noseYPosition: number;
	mouthType: number;
	mouthColor: number;
	mouthScale: number;
	mouthHorizontalStretch: number;
	mouthYPosition: number;
	mustacheType: number;
	unknown2: number;
	beardType: number;
	facialHairColor: number;
	mustacheScale: number;
	mustacheYPosition: number;
	glassesType: number;
	glassesColor: number;
	glassesScale: number;
	glassesYPosition: number;
	moleEnabled: boolean;
	moleScale: number;
	moleXPosition: number;
	moleYPosition: number;
	creatorName: string;
	checksum: number;

	studioUrl: (options: MiiStudioURLOptions) => string;
	encode: () => Buffer;
	validate: () => void;
};